]> git.ipfire.org Git - ipfire-2.x.git/blame_incremental - make.sh
kleiner Zwischenfix
[ipfire-2.x.git] / make.sh
... / ...
CommitLineData
1#!/bin/bash
2############################################################################
3# #
4# This file is part of the IPFire Firewall. #
5# #
6# IPFire is free software; you can redistribute it and/or modify #
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
11# IPFire is distributed in the hope that it will be useful, #
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
17# along with IPFire; if not, write to the Free Software #
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
20# Copyright (C) 2006 IPFire-Team <info@ipfire.eu>. #
21# #
22############################################################################
23#
24
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
27VERSION="2.0b" # Version number
28SLOGAN="www.ipfire.org" # Software slogan
29CONFIG_ROOT=/var/ipfire # Configuration rootdir
30NICE=10 # Nice level
31MAX_RETRIES=1 # prefetch/check loop
32KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33MACHINE=`uname -m`
34SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36IPFVER="full" # Which versions should be compiled? (full|light|voice|devel)
37
38# Set an information about the build number
39if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41fi
42
43# Debian specific settings
44if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53fi
54
55PWD=`pwd`
56BASENAME=`basename $0`
57BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58LOGFILE=$BASEDIR/log/_build.preparation.log
59export BASEDIR LOGFILE
60DIR_CHK=$BASEDIR/cache/check
61mkdir $BASEDIR/log/ 2>/dev/null
62
63# Include funtions
64. tools/make-functions
65
66if [ -f .config ]; then
67 . .config
68else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76fi
77
78prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j4"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213}
214
215buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253}
254
255buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 libaal
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 net-tools
302 lfsmake2 patch
303 lfsmake2 psmisc
304 lfsmake2 reiser4progs
305 lfsmake2 shadow
306 lfsmake2 sysklogd
307 lfsmake2 sysvinit
308 lfsmake2 tar
309 lfsmake2 texinfo
310 lfsmake2 udev
311 lfsmake2 util-linux
312 lfsmake2 vim
313 lfsmake2 grub
314}
315
316buildipfire() {
317 LOGFILE="$BASEDIR/log/_build.ipfire.log"
318 export LOGFILE
319 ipfiremake configroot
320 ipfiremake dhcp
321 ipfiremake dhcpcd
322 ipfiremake libusb
323 ipfiremake libpcap
324 ipfiremake linux-atm
325 ipfiremake ppp
326 ipfiremake rp-pppoe
327 ipfiremake unzip
328 ipfiremake linux SMP=1
329 ipfiremake ipp2p SMP=1
330 ipfiremake fcdsl SMP=1
331 ipfiremake fcdsl2 SMP=1
332 ipfiremake fcdslsl SMP=1
333 ipfiremake fcdslusb SMP=1
334 ipfiremake fcdslslusb SMP=1
335 ipfiremake fcpci SMP=1
336# ipfiremake promise-sata-300-tx SMP=1
337 ipfiremake zaptel SMP=1
338 ipfiremake fuse SMP=1
339 ipfiremake linux
340 ipfiremake ipp2p
341 ipfiremake fcdsl
342 ipfiremake fcdsl2
343 ipfiremake fcdslsl
344 ipfiremake fcdslusb
345 ipfiremake fcdslslusb
346 ipfiremake fcpci
347# ipfiremake promise-sata-300-tx
348 ipfiremake zaptel
349 ipfiremake fuse
350 ipfiremake pkg-config
351 ipfiremake cpio
352 ipfiremake expat
353 ipfiremake gdbm
354 ipfiremake gmp
355 ipfiremake pam
356 ipfiremake openssl
357 ipfiremake python
358 ipfiremake libnet
359 ipfiremake libjpeg
360 ipfiremake libpng
361 ipfiremake libtiff
362 ipfiremake lcms
363 ipfiremake libmng
364 ipfiremake freetype
365 ipfiremake libart
366 ipfiremake gd
367 ipfiremake popt
368 ipfiremake pcre
369 ipfiremake slang
370 ipfiremake newt
371 ipfiremake libcap
372 ipfiremake pciutils
373 ipfiremake libxml2
374 ipfiremake BerkeleyDB
375 ipfiremake mysql
376 ipfiremake cyrus-sasl
377 ipfiremake openldap
378 ipfiremake apache2
379 ipfiremake php
380 ipfiremake apache2 PASS=C
381 ipfiremake arping
382 ipfiremake beep
383 ipfiremake bind
384 ipfiremake capi4k-utils
385 ipfiremake cdrtools
386 ipfiremake dnsmasq
387 ipfiremake libaal
388 ipfiremake dosfstools
389 ipfiremake reiserfsprogs
390 ipfiremake squashfstools
391 ipfiremake sysfsutils
392 ipfiremake ntfs-3g
393 ipfiremake ethtool
394 ipfiremake ez-ipupdate
395 ipfiremake fcron
396 ipfiremake GD
397 ipfiremake GD-Graph
398 ipfiremake GD-TextUtil
399 ipfiremake gnupg
400 ipfiremake hdparm
401 ipfiremake ibod
402 ipfiremake initscripts
403 ipfiremake iptables
404 ipfiremake libupnp
405 ipfiremake ipp2p IPT=1
406 ipfiremake moblock
407 ipfiremake linux-igd
408 ipfiremake ipac-ng
409 ipfiremake ipaddr
410 ipfiremake iptstate
411 ipfiremake iputils
412 ipfiremake l7-protocols
413 ipfiremake isapnptools
414# ipfiremake isdn4k-utils # What about mISDN???
415 ipfiremake hwdata
416 ipfiremake kudzu
417 ipfiremake logrotate
418 ipfiremake logwatch
419 ipfiremake misc-progs
420 ipfiremake mtools
421 ipfiremake nano
422 ipfiremake nash
423 ipfiremake nasm
424 ipfiremake URI
425 ipfiremake HTML-Tagset
426 ipfiremake HTML-Parser
427 ipfiremake Compress-Zlib
428 ipfiremake Digest
429 ipfiremake Digest-SHA1
430 ipfiremake Digest-HMAC
431 ipfiremake libwww-perl
432 ipfiremake Net-DNS
433 ipfiremake Net-IPv4Addr
434 ipfiremake Net_SSLeay
435 ipfiremake IO-Stringy
436 ipfiremake Unix-Syslog
437 ipfiremake Mail-Tools
438 ipfiremake MIME-Tools
439 ipfiremake Net-Server
440 ipfiremake Convert-TNEF
441 ipfiremake Convert-UUlib
442 ipfiremake Archive-Tar
443 ipfiremake Archive-Zip
444 ipfiremake Text-Tabs+Wrap
445 ipfiremake Locale-Country
446 ipfiremake XML-Parser
447 ipfiremake glib
448 ipfiremake dbus
449 ipfiremake hal
450 ipfiremake hwinfo
451 ipfiremake GeoIP
452 ipfiremake fwhits
453 ipfiremake noip_updater
454 ipfiremake ntp
455 ipfiremake oinkmaster
456 ipfiremake openssh
457 ipfiremake openswan
458 ipfiremake pptpclient
459 ipfiremake rrdtool
460 ipfiremake setserial
461 ipfiremake setup
462 ipfiremake snort
463 ipfiremake squid
464 ipfiremake squid-graph
465 ipfiremake squidguard
466 ipfiremake tcpdump
467 ipfiremake traceroute
468 ipfiremake vlan
469 ipfiremake wireless
470 ipfiremake libsafe
471 ipfiremake 3c5x9setup
472 ipfiremake pakfire
473 ipfiremake java
474 ipfiremake bootsplash
475 ipfiremake spandsp
476 ipfiremake lzo
477 ipfiremake openvpn
478 ipfiremake pammysql
479 ipfiremake xinetd
480 ipfiremake ghostscript
481 ipfiremake cups
482 ipfiremake samba
483 ipfiremake sudo
484 ipfiremake mc
485 ipfiremake wget
486 ipfiremake wput
487 ipfiremake bridge-utils
488 ipfiremake screen
489 ipfiremake hddtemp
490 ipfiremake smartmontools
491 ipfiremake htop
492 ipfiremake lynx
493 ipfiremake postfix
494 ipfiremake procmail
495 ipfiremake fetchmail
496 ipfiremake cyrusimap
497 ipfiremake webcyradm
498 ipfiremake mailx
499 ipfiremake clamav
500 ipfiremake razor
501 ipfiremake spamassassin
502 ipfiremake amavisd
503 ipfiremake stund
504 ipfiremake libpri
505# ipfiremake bristuff
506 ipfiremake asterisk
507 ipfiremake mpg123
508 ipfiremake libmad
509 ipfiremake libogg
510 ipfiremake libvorbis
511 ipfiremake lame
512 ipfiremake xvid
513 ipfiremake mpeg2dec
514 ipfiremake ffmpeg
515 ipfiremake sox
516 ipfiremake gnump3d
517 ipfiremake videolan
518 ipfiremake applejuice
519 ipfiremake ocaml
520 ipfiremake mldonkey
521 ipfiremake ntop
522 ipfiremake rsync
523 ipfiremake tcpwrapper
524 ipfiremake portmap
525 ipfiremake nfs
526 ipfiremake nmap
527 ipfiremake mbmon
528 ipfiremake iftop
529 ipfiremake ncftp
530 ipfiremake cftp
531 ipfiremake etherwake
532 ipfiremake ethereal
533 ipfiremake tftp-hpa
534 ipfiremake iptraf
535 ipfiremake nagios
536}
537
538buildinstaller() {
539 # Run installer scripts one by one
540 LOGFILE="$BASEDIR/log/_build.installer.log"
541 export LOGFILE
542 ipfiremake syslinux
543 ipfiremake as86
544 ipfiremake mbr
545 ipfiremake memtest
546 installmake linux-libc-header
547 installmake binutils
548 ipfiremake uClibc PASS=1
549 ipfiremake gcc INST=1
550 installmake uClibc PASS=2
551 installmake gcc INST=2
552 installmake uClibc PASS=3
553 installmake busybox
554 installmake udev
555 installmake slang
556 installmake newt
557 installmake gettext
558 installmake kbd
559 installmake popt
560 installmake sysvinit
561 installmake misc-progs
562 installmake e2fsprogs
563 installmake libaal
564 installmake reiser4progs
565 installmake reiserfsprogs
566 installmake sysfsutils
567 installmake util-linux
568 installmake pciutils
569 installmake zlib
570 installmake wget
571 installmake libxml2
572 installmake dbus
573 installmake hal
574 installmake hwdata
575 installmake hwinfo
576 installmake kudzu
577 installmake installer
578 installmake initrd
579}
580
581buildpackages() {
582 LOGFILE="$BASEDIR/log/_build.packages.log"
583 export LOGFILE
584 echo "... see detailed log in _build.*.log files" >> $LOGFILE
585
586 installmake strip
587
588 # Generating list of packages used
589 echo -n "Generating packages list from logs" | tee -a $LOGFILE
590 rm -f $BASEDIR/doc/packages-list
591 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
592 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
593 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
594 fi
595 done
596 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
597 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
598 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
599 rm -f $BASEDIR/doc/packages-list
600 # packages-list.txt is ready to be displayed for wiki page
601 beautify message DONE
602
603 # Create images for install
604 for i in $IPFVER
605 do
606 if [ $i == "devel" ]; then
607 if [ ! -e ipfire-$VERSION.i586-devel.iso ]; then
608 ipfiremake cdrom ED=$i
609 fi
610 else
611 ipfiremake cdrom ED=$i
612 fi
613 done
614
615 # Check if there is a loop device for building in virtual environments
616 if [ -e /dev/loop0 ]; then
617 ipfiremake usb-stick
618 fi
619 ipfiremake pxe
620 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
621
622# ipfirepackages
623
624 # Cleanup
625 stdumount
626 rm -rf $BASEDIR/build/tmp/*
627
628 # Generating total list of files
629 echo "Generating files list from logs" | tee -a $LOGFILE
630 rm -f $BASEDIR/log/FILES
631 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
632 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
633 echo "##" >>$BASEDIR/log/FILES
634 echo "## `basename $i`" >>$BASEDIR/log/FILES
635 echo "##" >>$BASEDIR/log/FILES
636 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
637 fi
638 done
639 cd $BASEDIR/packages; ls -w1 *.ipfire | awk -F ".ipfire" '{ print $1 }' > $BASEDIR/packages/packages_list.txt
640 echo -n "###EOF###" >> $BASEDIR/packages/packages_list.txt
641
642 cd $PWD
643}
644
645ipfirepackages() {
646 if [ -d "$BASEDIR/packages" ]; then
647 for i in `ls $BASEDIR/packages`; do
648 touch $BASEDIR/build/install/packages/$i.empty
649 done
650 fi
651# ipfiredist amavisd
652 ipfiredist applejuice
653 ipfiredist asterisk
654 ipfiredist clamav
655 ipfiredist cups
656 ipfiredist cyrusimap
657 ipfiredist fetchmail
658 ipfiredist ffmpeg
659 ipfiredist gnump3d
660 ipfiredist iptraf
661 ipfiredist java
662 ipfiredist lame
663 ipfiredist libmad
664 ipfiredist libogg
665 ipfiredist libvorbis
666 ipfiredist mailx
667 ipfiredist mldonkey
668 ipfiredist mpeg2dec
669 ipfiredist nagios
670 ipfiredist nfs
671 ipfiredist nmap
672 ipfiredist ntop
673 ipfiredist portmap
674 ipfiredist postfix
675 ipfiredist procmail
676 ipfiredist samba
677 ipfiredist sox
678 ipfiredist spamassassin
679 ipfiredist subversion
680 ipfiredist videolan
681 ipfiredist webcyradm
682 ipfiredist xvid
683 ipfiredist yasuc
684 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
685 mv -f $LFS/install/packages/*.{ipfire,md5} $BASEDIR/packages >> $LOGFILE 2>&1
686 rm -rf $BASEDIR/build/install/packages/*
687}
688
689# See what we're supposed to do
690case "$1" in
691build)
692 clear
693 BUILDMACHINE=`uname -m`
694 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
695 #only restore on a clean disk
696 if [ ! -f log/cleanup-toolchain-2-tools ]; then
697 if [ ! -n "$PACKAGE" ]; then
698 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
699 prepareenv
700 buildtoolchain
701 else
702 PACKAGENAME=${PACKAGE%.tar.gz}
703 beautify build_stage "Packaged toolchain compilation"
704 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
705 tar zxf $PACKAGE
706 prepareenv
707 else
708 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
709 fi
710 fi
711 else
712 echo -n "Using installed toolchain" | tee -a $LOGFILE
713 beautify message SKIP
714 prepareenv
715 fi
716
717 beautify build_start
718 beautify build_stage "Building LFS"
719 buildbase
720
721 beautify build_stage "Building IPFire"
722 buildipfire
723
724 # Setzen des IPFire Builds
725 if [ "$FIREBUILD" ]; then
726 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
727 else
728 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
729 fi
730
731 beautify build_stage "Building installer"
732 buildinstaller
733
734 beautify build_stage "Building packages"
735 buildpackages
736 beautify build_end
737 ;;
738shell)
739 # enter a shell inside LFS chroot
740 # may be used to changed kernel settings
741 prepareenv
742 entershell
743 ;;
744changelog)
745 echo -n "Loading new Changelog from SVN: "
746 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
747 beautify message DONE
748 ;;
749clean)
750 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
751 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
752 $LOSETUP -d $i 2>/dev/null
753 done
754 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
755 umount $i
756 done
757 stdumount
758 for i in `seq 0 7`; do
759 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
760 umount /dev/loop${i} 2>/dev/null;
761 losetup -d /dev/loop${i} 2>/dev/null;
762 fi;
763 done
764 rm -rf $BASEDIR/build
765 rm -rf $BASEDIR/cdrom
766 rm -rf $BASEDIR/packages
767 rm -rf $BASEDIR/log
768 if [ -h /tools ]; then
769 rm -f /tools
770 fi
771 beautify message DONE
772 ;;
773downloadsrc)
774 if [ ! -d $BASEDIR/cache ]; then
775 mkdir $BASEDIR/cache
776 fi
777 mkdir -p $BASEDIR/log
778 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
779 FINISHED=0
780 cd $BASEDIR/lfs
781 for c in `seq $MAX_RETRIES`; do
782 if (( FINISHED==1 )); then
783 break
784 fi
785 FINISHED=1
786 cd $BASEDIR/lfs
787 for i in *; do
788 if [ -f "$i" -a "$i" != "Config" ]; then
789 echo -ne "Loading $i"
790 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
791 if [ $? -ne 0 ]; then
792 beautify message FAIL
793 FINISHED=0
794 else
795 if [ $c -eq 1 ]; then
796 beautify message DONE
797 fi
798 fi
799 fi
800 done
801 done
802 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
803 ERROR=0
804 for i in *; do
805 if [ -f "$i" -a "$i" != "Config" ]; then
806 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
807 if [ $? -ne 0 ]; then
808 echo -ne "MD5 difference in lfs/$i"
809 beautify message FAIL
810 ERROR=1
811 fi
812 fi
813 done
814 if [ $ERROR -eq 0 ]; then
815 echo -ne "${BOLD}all files md5sum match${NORMAL}"
816 beautify message DONE
817 else
818 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
819 beautify message FAIL
820 fi
821 cd - >/dev/null 2>&1
822 ;;
823toolchain)
824 clear
825 prepareenv
826 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
827 buildtoolchain
828 BUILDMACHINE=`uname -m`
829 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
830 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
831 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
832 build/{bin,etc,usr/bin,usr/local} \
833 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
834 log >> $LOGFILE
835 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
836 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
837 stdumount
838 ;;
839gettoolchain)
840 BUILDMACHINE=`uname -m`
841 # arbitrary name to be updated in case of new toolchain package upload
842 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
843 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
844 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
845 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
846 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
847 cd $BASEDIR/cache/toolchains
848 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
849 if [ $? -ne 0 ]; then
850 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
851 else
852 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
853 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
854 else
855 exiterror "$PACKAGE.md5 did not match, check downloaded package"
856 fi
857 fi
858 else
859 echo "Toolchain is already downloaded. Exiting..."
860 fi
861 ;;
862othersrc)
863 prepareenv
864 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
865 chroot $LFS /tools/bin/env -i HOME=/root \
866 TERM=$TERM PS1='\u:\w\$ ' \
867 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
868 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
869 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
870 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
871 if [ $? -eq "0" ]; then
872 beautify message DONE
873 else
874 beautify message FAIL
875 fi
876 stdumount
877 ;;
878svn)
879 case "$2" in
880 update|up)
881 # clear
882 echo -ne "Loading the latest source files...\n"
883 if [ $3 ]; then
884 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
885 else
886 svn update | tee -a $PWD/log/_build.svn.update.log
887 fi
888 if [ $? -eq "0" ]; then
889 beautify message DONE
890 else
891 beautify message FAIL
892 exit 1
893 fi
894 echo -ne "Writing the svn-info to a file"
895 svn info > $PWD/svn_status
896 if [ $? -eq "0" ]; then
897 beautify message DONE
898 else
899 beautify message FAIL
900 exit 1
901 fi
902 chmod 755 $0
903 exit 0
904 ;;
905 commit|ci)
906 clear
907 if [ -f /usr/bin/mcedit ]; then
908 export EDITOR=/usr/bin/mcedit
909 fi
910 if [ -f /usr/bin/nano ]; then
911 export EDITOR=/usr/bin/nano
912 fi
913 echo -ne "Selecting editor $EDITOR..."
914 beautify message DONE
915 if [ -e /sbin/yast ]; then
916 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
917 $0 changelog
918 fi
919 fi
920 update_langs
921 svn commit
922 $0 svn up
923 if [ -n "$FTP_CACHE_URL" ]; then
924 $0 uploadsrc
925 fi
926 ;;
927 dist)
928 if [ $3 ]; then
929 SVN_REVISION=$3
930 fi
931 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
932 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
933 exit 0
934 fi
935 echo -en "REV $SVN_REVISION: Downloading..."
936 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
937 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
938 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
939 evaluate 1
940
941 echo -en "REV $SVN_REVISION: Compressing files..."
942 if [ -e ipfire-source/trunk/make.sh ]; then
943 chmod 755 ipfire-source/trunk/make.sh
944 fi
945 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
946 evaluate 1
947 echo -en "REV $SVN_REVISION: Cleaning up..."
948 rm ipfire-source/ -r
949 evaluate 1
950 ;;
951 diff|di)
952 echo -ne "Make a local diff to last svn revision"
953 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
954 evaluate 1
955 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
956 ;;
957 esac
958 ;;
959uploadsrc)
960 PWD=`pwd`
961 cd $BASEDIR/cache/
962 echo -e "Uploading cache to ftp server:"
963 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /tmp/ftplist
964 for i in *; do
965 if [ "$i" == "toolchains" ]; then continue; fi
966 grep -q $i /tmp/ftplist
967 if [ "$?" -ne "0" ]; then
968 echo -ne "$i"
969 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
970 if [ "$?" -ne "0" ]; then
971 beautify message FAIL
972 fi
973 fi
974 done
975 rm -f /tmp/ftplist
976 cd $PWD
977 exit 0
978 ;;
979upload)
980 case "$2" in
981 iso)
982 echo -e "Uploading the iso to $IPFIRE_FTP_URL_EXT."
983 cat <<EOF > .ftp-commands
984mkdir $IPFIRE_FTP_PATH_EXT
985ls -lah
986quit
987EOF
988 ncftp -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT < .ftp-commands
989 rm -f .ftp-commands
990 md5sum ipfire-install-$VERSION.i386.iso > ipfire-install-$VERSION.i386.iso.md5
991 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-install-$VERSION.i386.iso
992 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-install-$VERSION.i386.iso.md5
993 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-source-r$SVN_REVISION.tar.gz
994 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ svn_status
995 if [ "$?" -eq "0" ]; then
996 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $IPFIRE_FTP_URL_EXT$IPFIRE_FTP_PATH_EXT/."
997 else
998 echo -e "There was an error while uploading the iso to the ftp server."
999 exit 1
1000 fi
1001 if [ "$3" = "--with-sources-cd" ]; then
1002 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-sources-cd-$VERSION.$MACHINE.iso
1003 fi
1004 ;;
1005 paks)
1006 cat <<EOF > .ftp-commands
1007mkdir $IPFIRE_FTP_PATH_PAK
1008ls -lah
1009quit
1010EOF
1011 ncftp -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK < .ftp-commands
1012 rm -f .ftp-commands
1013 ncftpput -z -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK $IPFIRE_FTP_PATH_PAK/ packages/*
1014 if [ "$?" -eq "0" ]; then
1015 echo -e "The packages were successfully uploaded to $IPFIRE_FTP_URL_PAK$IPFIRE_FTP_PATH_PAK/."
1016 else
1017 echo -e "There was an error while uploading the packages to the ftp server."
1018 exit 1
1019 fi
1020 ;;
1021 esac
1022 ;;
1023batch)
1024 if [ "$2" = "--background" ]; then
1025 batch_script
1026 exit $?
1027 fi
1028 if [ `screen -ls | grep -q ipfire` ]; then
1029 echo "Build is already running, sorry!"
1030 exit 1
1031 else
1032 if [ "$2" = "--rebuild" ]; then
1033 export IPFIRE_REBUILD=1
1034 echo "REBUILD!"
1035 else
1036 export IPFIRE_REBUILD=0
1037 fi
1038 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1039 screen -dmS ipfire $0 batch --background
1040 evaluate 1
1041 exit 0
1042 fi
1043 ;;
1044watch)
1045 watch_screen
1046 ;;
1047pxe)
1048 case "$2" in
1049 start)
1050 start_tftpd
1051 ;;
1052 stop)
1053 stop_tftpd
1054 ;;
1055 reload|restart)
1056 reload_tftpd
1057 ;;
1058 esac
1059 exit 0
1060 ;;
1061"")
1062 clear
1063 svn info
1064 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1065 do
1066 case $name in
1067 "IPFIRE: Downloadsrc")
1068 $0 downloadsrc
1069 ;;
1070 "IPFIRE: Build (silent)")
1071 $0 build-silent
1072 ;;
1073 "IPFIRE: Watch Build")
1074 $0 watch
1075 ;;
1076 "IPFIRE: Batch")
1077 $0 batch
1078 ;;
1079 "IPFIRE: Clean")
1080 $0 clean
1081 ;;
1082 "SVN: Update")
1083 $0 svn update
1084 ;;
1085 "Help")
1086 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1087 cat doc/make.sh-usage
1088 ;;
1089 "LOG: Tail")
1090 tail -f log/_*
1091 ;;
1092 "Exit")
1093 break
1094 ;;
1095 esac
1096 done
1097 ;;
1098config)
1099 make_config
1100 ;;
1101*)
1102 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1103 cat doc/make.sh-usage
1104 ;;
1105esac